CWIS Developer Documentation

- Home
- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
SPTUser Class Reference
Inheritance diagram for SPTUser:
[legend]
Collaboration diagram for SPTUser:
[legend]

## Public Member Functions
| __construct ($UserInfo=NULL)
Public Member Functions inherited from CWUser
| __construct ($UserInfo=NULL)
| Load user data from the given user info or from the session if available. More...
| Privileges (PrivilegeSet $NewValue=NULL)
| THIS FUNCTION HAS BEEN DEPRECATED This provides compatibility for interfaces written to use a version of PrivilegeSet from CWIS 3.0.0 to 3.1.0. More...
| ResourceId ()
| Get the ID of the user resource associated with the user. More...
| GetResource ()
| Get the associated user resource for this user. More...
| HasPriv ($Privilege, $Privileges=NULL)
| Determine if a user has a given privilege, or satisfies the conditions specified by a given privilege set. More...
| Delete ()
| Delete the user and its associated user resource. More...
| Get ($FieldName)
| Get a value from the specified field. More...
| Set ($FieldName, $NewValue)
| Set a value for the specified field. More...
| PrefFontSize ($NewValue=DB_NOVALUE)
| PrefFontTypeFace ($NewValue=DB_NOVALUE)
| PrefFontColor ($NewValue=DB_NOVALUE)
| PrefBackgroundColor ($NewValue=DB_NOVALUE)
| PrefColorAvoidanceFlags ($NewValue=DB_NOVALUE)
| PrefContentDensity ($NewValue=DB_NOVALUE)
| PrefContentView ($NewValue=DB_NOVALUE)
| PrefAudioDescriptionLevel ($NewValue=DB_NOVALUE)
| PrefAudioDescriptionLanguage ($NewValue=DB_NOVALUE)
| PrefVisualDescriptionLanguage ($NewValue=DB_NOVALUE)
| PrefImageDescriptionLanguage ($NewValue=DB_NOVALUE)
| PrefUseGraphicAlternatives ($NewValue=DB_NOVALUE)
| PrefSignLanguage ($NewValue=DB_NOVALUE)
| PrefCaptionType ($NewValue=DB_NOVALUE)
| PrefCaptionRate ($NewValue=DB_NOVALUE)
Public Member Functions inherited from User
| User ($UserInfoOne=NULL, $UserInfoTwo=NULL)
| Status ()
| StatusMessage ($StatusCode=NULL)
| Delete ()
| Id ()
| Name ()
| GetBestName ()
| Get the best available name associated with a user, i.e., the real name or, if it isn't available, the user name. More...
| LastLocation ($NewLocation=NULL)
| LastActiveDate ()
| LastIPAddress ()
| Get ($FieldName)
| GetDate ($FieldName, $Format="")
| Set ($FieldName, $NewValue)
| Login ($UserName, $Password, $IgnorePassword=FALSE)
| Logout ()
| GetPasswordSalt ($UserName)
| IsLoggedIn ()
| IsNotLoggedIn ()
| ChangePassword ($OldPassword, $NewPassword, $NewPasswordAgain)
| SetPassword ($NewPassword)
| CreateNewUserWithEMailedPassword ($UserName, $EMail, $EMailAgain, $TemplateFile="Axis--User--EMailTemplate.txt")
| CreateNewUserAndMailPasswordFromFile ($UserName, $EMail, $EMailAgain, $TemplateFile="Axis--User--EMailTemplate.txt")
| CreateNewUserAndMailPassword ($UserName, $EMail, $EMailAgain, $EMailSubject, $EMailBody)
| GetActivationCode ()
| IsActivationCodeGood ($Code)
| IsActivated ($NewValue=DB_NOVALUE)
| GetResetCode ()
| IsResetCodeGood ($Code)
| GetMailChangeCode ()
| IsMailChangeCodeGood ($Code)
| SendEMail ($TemplateTextOrFileName, $FromAddress=NULL, $MoreSubstitutions=NULL, $ToAddress=NULL)
| HasPriv ($Privilege, $Privileges=NULL)
| Check whether user has specified privilege(s). More...
| GrantPriv ($Privilege)
| RevokePriv ($Privilege)
| GetPrivList ()
| SetPrivList ($NewPrivileges)
| GetUniqueCode ($SeedString, $CodeLength)
| GetRandomPassword ($PasswordMinLength=6, $PasswordMaxLength=8)
| UpdateValue ($FieldName, $NewValue=DB_NOVALUE)
| GivePriv ($Privilege)

## Static Public Member Functions
static | GetCryptKey ()
| Get/generate a cryptographic keypair for user login. More...
static | ExtractPubKeyParameters ($KeyPair)
| Extract the modulus and exponent of the public key from an OpenSSL format keypair to send in login forms. More...
Static Public Member Functions inherited from CWUser
static | EmailWrapper ($To, $Subject, $Message, $AdditionalHeaders)
| Adapter method to bridge between AxisPHP User class and ScoutLib Email class. More...
static | GetCustomUserFields ()
| Get all custom user fields. More...
static | GetDefaultUserFields ()
| Get the default user fields. More...
Static Public Member Functions inherited from User
static | SetEmailFunction ($NewValue)
| Set email function to use instead of mail(). More...
static | GetSqlQueryForUsersWithPriv ($Privilege, $Privileges=NULL)
| Get an SQL query that will return IDs of all users that have the specified privilege flags. More...
static | GetSqlQueryForUsersWithoutPriv ($Privilege, $Privileges=NULL)
| Get an SQL query that will return IDs of all users that do not have the specified privilege flags. More...
static | IsValidUserName ($UserName)
static | IsValidPassword ($Password)
static | IsValidLookingEMailAddress ($EMail)
static | NormalizeEMailAddress ($EMailAddress)
static | NormalizeUserName ($UserName)
static | NormalizePassword ($Password)

## Additional Inherited Members
Public Attributes inherited from CWUser
const | UIPREF_AVOID_RED = 1
const | UIPREF_AVOID_REDGREEN = 2
const | UIPREF_AVOID_BLUEYELLOW = 4
const | UIPREF_AVOID_GREENYELLOW = 8
const | UIPREF_AVOID_ORANGE = 16
const | UIPREF_AVOID_REDBLACK = 32
const | UIPREF_AVOID_PURPLEGREY = 64
const | UIPREF_AVOID_USEMAXMONOCHR = 128
const | UIPREF_CONTENTDENSITY_NOPREFERENCE = 0
const | UIPREF_CONTENTDENSITY_DETAILED = 1
const | UIPREF_CONTENTDENSITY_OVERVIEW = 2
const | UIPREF_CONTENTVIEW_NOPREFERENCE = 0
const | UIPREF_CONTENTVIEW_TEXTINTENSIVE = 1
const | UIPREF_CONTENTVIEW_IMAGEINTENSIVE = 2
const | UIPREF_AUDIODESCRIPTION_NONE = 0
const | UIPREF_AUDIODESCRIPTION_STANDARD = 1
const | UIPREF_AUDIODESCRIPTION_EXPANDED = 2
const | UIPREF_CAPTIONTYPE_NONE = 0
const | UIPREF_CAPTIONTYPE_VERBATIM = 1
const | UIPREF_CAPTIONTYPE_REDUCEDREADINGLEVEL = 2
Protected Member Functions inherited from CWUser
| FetchAssociatedResource ($UserId)
| Fetch the associated user resource based off of a user ID. More...
| IsResourceObjectSet ()
| Determine if the resource object for this object is set. More...
Protected Attributes inherited from CWUser
| $Resource
| The user resource associated with the user or NULL if the user isn't logged in. More...
Protected Attributes inherited from User
| $DB
| $UserId = NULL
| $Result
| $LoggedIn
Static Protected Attributes inherited from CWUser
static | $MigratedUserFields
| Fields that were previously part of the APUsers table that have been migrated to the Resources table as of CWIS 3.0.0. More...

## Detailed Description

Definition at line 11 of file SPTUser.php.

## Constructor & Destructor Documentation

SPTUser::__construct | ( |  | $UserInfo = `NULL` | ) |

Definition at line 16 of file SPTUser.php.

References User\User().

## Member Function Documentation

static SPTUser::ExtractPubKeyParameters | ( |  | $KeyPair | ) |
| static

Extract the modulus and exponent of the public key from an OpenSSL format keypair to send in login forms.

Parameters

  resource | $KeyPair | An openssl format keypair as returned by SPTUser::GetCryptKey().

Returns
  Associative array containing "Modulus" and "Exponent" key parameters

Definition at line 84 of file SPTUser.php.

static SPTUser::GetCryptKey | ( |  | ) |
| static

Get/generate a cryptographic keypair for user login.

CWIS can use RSA encryption on the password field of login forms. This function gets the most recently generated keypair, clearing out keys older than 48 hours, and re-generating a new key if the most recent one is older than 24 hours.

Returns
  openssl format keypair

Definition at line 31 of file SPTUser.php.

References User\$DB.

The documentation for this class was generated from the following file:

- objects/SPTUser.php